controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\ContactForm;
use yii\data\ActiveDataProvider;
use app\models\Productos;
use yii\helpers\Html;
use yii\helpers\ArrayHelper;




class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionCategorias(){
        //ListView
           
            $dataProvider = new ActiveDataProvider([
            "query" => Productos::find() -> select ('categorias')->distinct(),
        ]);
            return $this->render('categorias',[
                
            'dataProvider' => $dataProvider
        ]);        
    }
    
    public function actionProductos(){
        //GridView - tabla
           
            $dataProvider = new ActiveDataProvider([
            "query" => Productos::find(),
        ]);
            return $this->render('productos',[
                
            'dataProvider' => $dataProvider
        ]);        
    }
    
    public function actionOfertas(){
        //ListView - lista
           
            $dataProvider = new ActiveDataProvider([
            "query" => Productos::find() -> where (['oferta'=>1]),
        ]);
            return $this->render('ofertas',[
                
            'dataProvider' => $dataProvider
        ]);        
    }
    
    public function actionVer($categoria){
        $productos = Productos::find()->where(['categorias'=>$categoria]);
        $dataProvider = new ActiveDataProvider([
            'query' => $productos,
            ]);
            return $this->render('ver',[
                'dataProvider'=> $dataProvider,
                'categoria' => $categoria
            ]);
        
    }
    
    public function actionDonde() {
        return $this-> render('donde');
    }
    
    public function actionQuienes() {
        return $this-> render('quienes');
    }
    
    public function actionNuestros(){
        $fotos= Productos::find()
                ->select("foto")
                ->where(["oferta" => 1])
                ->asArray()
                ->all();
        $fotos= ArrayHelper::getColumn($fotos, "foto");
        $salida=[];
        foreach ($fotos as $src){
            $salida[]=Html::img("@web/imgs/$src");
        }
        return $this-> render('nuestros',[
            "fotos" =>$salida,
        ]);
    }
    
    public function actionInformacion() {
        return $this-> render('informacion');
    }

    
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }
    public function actionVermas($id){
        //metodo1
       // $salida=Productos::find()->where(["id"=>$id]);
        //metodo2
        $salida= Productos::findOne($id);
        
        return $this->render("vermas",[
            "model" => $salida
        ]);
        
        
    }

}

views/site/_categorias.php
<?php

use yii\helpers\Html;

echo Html::a($model->categorias,
        ['site/ver','categoria'=>$model->categorias],
        ['class'=>'col-lg-12 d-block p-4 mb-5 btn btn-primary']
        );

views/site/_ofertas.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?></div>
        <div class="bg-warning rounded p-2">Descripción:</div>
        <div class="p-1"><?= substr($model->descripcion, 0, 250) . "..."?></div>
        <div class="bg-warning rounded p-2">Categoria:</div>
        <div class="p-1"><?= $model->categorias ?></div>
        <?= Html::a ("Ver mas", ["site/vermas","id"=>$model->id],["class" => "btn btn-danger float-right "])?>
     
    </div>
    
</div>

views/site/_ver.php
<?php
use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-5">
    <?php
    echo Html::img("@web/imgs/$model->foto",[
    "class" =>"card-img-top"
    ]);
    
    ?>
    </div>
    <div class="col-lg-7">
        <h2><?= $model->nombre ?><br></h2>
        <div class="bg-warning rounded p-2">Precio:</div>
        <div class="p-1"><?= $model->precio ?></div>
        <div class="bg-warning rounded p-2">Descripción:</div>
        <div class="p-1"><?= $model->descripcion ?></div>
        
     
    </div>
    
</div>

views/site/categorias.php
<?php
use yii\widgets\ListView;
?>

<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Categorias</h1>
    
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_categorias",
    "itemOptions" => [
        'class' => 'col-lg-4',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;
use kartik\date\DatePicker;


$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>
                
                <?php    
            echo '<label class="control-label">Fecha</label>';
            echo DatePicker::widget([
                'model' => $model, 
                'attribute' => 'fecha',
                'language' => 'es',
                'options' => ['placeholder' => 'Introduce fecha'],
                'pluginOptions' => [
                    'todayHighlight' => true,
                    'todayBtn' => true,
                    'format' => 'dd/mm/yyyy',
                    'autoclose' => true,
                ]
            ]);
        ?>


                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error" align="center">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>
    <h2>
    <p>
        LA CAGADA.
    </p>
    </h2>
    <H1>
    <p>
        PERO CAGADA CAGADA.
    </p>
    </H1>   

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">LaJota</h1>

        <p class="lead">Productos LaJota, donde comprarás todo, menos cacota.</p>

        <p><a class="btn btn-lg btn-success" href="http://www.yiiframework.com">Get started with Yii</a></p>
    </div>

    <div class="body-content">

        <div class="row">
            
            <div >
                <div align="center">
                <h2>Cabecera</h2>
                </div>
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                <div align="center">
                <p><a class="btn btn-outline-secondary" href="http://www.yiiframework.com/forum/">Yii Forum &raquo;</a></p>
                </div>
            </div>
           
        </div>

    </div>
</div>

views/site/informacion.php
<h1>ESTAMOS TRABAJANDO EN ELLO</h1>

views/site/nuestros.php
<?php
use yii\bootstrap4\Carousel;
use yii\helpers\Html;
?>
<div align="center">
    <p>
        Mostraremos productos, cuando tengamos productos que mostrar
    </p>
    <?php
    echo Carousel::widget([
    'items' => $fotos,
        'options'=>[
            'class' => 'mx-auto col-lg-8'
        ],
        'controls' => ['<i class="fas fa-angle-double-left fa-5x"></i>','<i class="fas fa-angle-double-right fa-5x"></i>']
]);
    ?>

</div>

views/site/ofertas.php
<?php

use yii\widgets\ListView;
?>
<h1 class="list-group-item">Ofertas:</h1>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_ofertas',
    'options'=>[
        'class'=>'row'
        ],
    'layout'=>"{items}",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],

]);

views/site/productos.php
<?php



use yii\grid\GridView;
use yii\helpers\Html;


echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        'id',
        'nombre',
        [
            'attribute' =>'foto',
            'label'=>'foto',
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->foto;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=> 'width:300px']); 
            }
        ],
        'descripcion',
        'precio',
        'oferta',
    ],
]);

views/site/quienes.php
<div aling="center">
    <h1>El Rey de las Cantinas</h1>
<p>Me llaman el rey de las cantina
me llaman asi por burlarse los que no han sufrido las penas de amor
me dicen que soy un borracho no entienden que el hombre más macho</p>

<p>también ha bebido y llorado cuando fue engañado por una mujer
por eso con trago y cigarro
yo vivo ahogando mi vida</p>

<p>y se hace más grande mi herida
cuando me doy cuenta que te quiero más
me llaman el rey de las cantinas</p>

<p>porque en las cantinas yo paro matando una pena matando un amor
la quise como algo sagrado
la ame como a nadie en el mundo</p>

<p>pero ella se fue de mi lado
se marchó con otro se burló de mi
por eso estoy siempre tomando</p>

<p>no soy ningún rey de cantinas
mentira no soy un borracho
si tomo es de pena yo soy hombre macho</p>
</div>

views/site/ver.php
<?php
use yii\widgets\ListView;
?>
<h1 class="border rounded bg-secondary p-3 text-white text-center mb-5">Listado de productos de categoria<?= $categoria ?></h1>
<?php
echo ListView::widget([
    "dataProvider" => $dataProvider,
    "itemView" => "_ver",
    "itemOptions" => [
        'class' => 'col-lg-5 ml-auto mr-auto bg-light p-3 mb-5',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"
]);

views/site/vermas.php
<?php

use yii\widgets\DetailView;
use yii\helpers\Html;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'id',               // title attribute (in plain text)
        'description',    // description attribute in HTML
        'categoria',
        'precio',
        'oferta',
        [
            'atribute'=>'foto',
            'label'=>'foto',
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->foto;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=> 'width:300px']); 
            }
        ],
       
    ],
]);